class ParserLine(object):
    def __init__(self, input, depth, index=None, parent=None):
        self.content = input
        self.index = index
        self.depth = depth
        self.parent = parent
        self.childs = list()

    def containsChild(self, text):
        """ iter through self.childs and return the child's index 
            if text is found

            TODO: return all occurrences 
        """
        for index, child in enumerate(self.getAllChilds()):
            if text in child:
                """ since self.getAllChilds() first item it is self,
                    it is needed to decrement one """
                return index - 1
        return None

    def getAllChilds(self):
        """ returns every child INCLUDING itself """
        out = [self]
        for child in self.childs:
            out += self._recursiveChilds(child)
        return out

    def getAllParents(self):
        """ returns every parent and DO NOT include itself """
        return self._recursiveParents(self)[::-1]

    def _recursiveParents(self, line):
        if line.parent:
            return [line.parent] + self._recursiveParents(line.parent)
        return [line]

    def _recursiveChilds(self, child):
        if isinstance(child, ParserLine):
            if child.childs:
                return [child] + self._recursiveChilds(child.childs)
        if isinstance(child, list):
            out = []
            for c in child:
                out += self._recursiveChilds(c)
            return out
        return [child]

    def addChild(self, child_content, index=0):
        child = ParserLine(child_content, self.depth + 1, parent=self)
        self.childs.insert(index, child)

    def __repr__(self):
        return self.content

    def __contains__(self, item):
        if item in self.content:
            return True
        return False
